/**
 * kalu - Copyright (C) 2012-2014 Olivier Brunel
 *
 * updater-dbus.h
 * Copyright (C) 2014 Olivier Brunel <jjk@jjacky.com>
 *
 * This file is part of kalu.
 *
 * kalu is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * kalu is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * kalu. If not, see http://www.gnu.org/licenses/
 */

#ifndef _KALU_UPDATER_DBUS_H
#define _KALU_UPDATER_DBUS_H

#include "kupdater.h"

#define DBUS_NAME               "org.jjk.kalu"
#define OBJECT_PATH             "/org/jjk/kalu/Updater"
#define INTERFACE_NAME          "org.jjk.kalu.UpdaterInterface"


static const GDBusArgInfo _arg_Init_in_downloadonly = {
    -1,
    (gchar *) "downloadonly",
    (gchar *) "b",
    NULL
};
static const GDBusArgInfo * const _arg_Init_in[] = {
    &_arg_Init_in_downloadonly,
    NULL
};
static const GDBusMethodInfo _method_Init = {
    -1,
    (gchar *) "Init",
    (GDBusArgInfo **) (&_arg_Init_in),
    NULL,
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_rootdir = {
    -1,
    (gchar *) "rootdir",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_dbpath = {
    -1,
    (gchar *) "dbpath",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_logfile = {
    -1,
    (gchar *) "logfile",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_gpgdir = {
    -1,
    (gchar *) "gpgdir",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_hookdirs = {
    -1,
    (gchar *) "hookdirs",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_cachedirs = {
    -1,
    (gchar *) "cachedirs",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_siglevel = {
    -1,
    (gchar *) "siglevel",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_arch = {
    -1,
    (gchar *) "arch",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_checkspace = {
    -1,
    (gchar *) "checkspace",
    (gchar *) "b",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_usesyslog = {
    -1,
    (gchar *) "usesyslog",
    (gchar *) "b",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_usedelta = {
    -1,
    (gchar *) "usedelta",
    (gchar *) "d",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_ignorepkgs = {
    -1,
    (gchar *) "ignorepkgs",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_ignoregroups = {
    -1,
    (gchar *) "ignoregroups",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_noupgrades = {
    -1,
    (gchar *) "noupgrades",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo _arg_InitAlpm_in_noextracts = {
    -1,
    (gchar *) "noextracts",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo * const _arg_InitAlpm_in[] = {
    &_arg_InitAlpm_in_rootdir,
    &_arg_InitAlpm_in_dbpath,
    &_arg_InitAlpm_in_logfile,
    &_arg_InitAlpm_in_gpgdir,
    &_arg_InitAlpm_in_hookdirs,
    &_arg_InitAlpm_in_cachedirs,
    &_arg_InitAlpm_in_siglevel,
    &_arg_InitAlpm_in_arch,
    &_arg_InitAlpm_in_checkspace,
    &_arg_InitAlpm_in_usesyslog,
    &_arg_InitAlpm_in_usedelta,
    &_arg_InitAlpm_in_ignorepkgs,
    &_arg_InitAlpm_in_ignoregroups,
    &_arg_InitAlpm_in_noupgrades,
    &_arg_InitAlpm_in_noextracts,
    NULL
};
static const GDBusMethodInfo _method_InitAlpm = {
    -1,
    (gchar *) "InitAlpm",
    (GDBusArgInfo **) (&_arg_InitAlpm_in),
    NULL,
    NULL
};
static const GDBusArgInfo _arg_AddDb_in_name = {
    -1,
    (gchar *) "name",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AddDb_in_siglevel = {
    -1,
    (gchar *) "siglevel",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_AddDb_in_servers = {
    -1,
    (gchar *) "servers",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo * const _arg_AddDb_in[] = {
    &_arg_AddDb_in_name,
    &_arg_AddDb_in_siglevel,
    &_arg_AddDb_in_servers,
    NULL
};
static const GDBusMethodInfo _method_AddDb = {
    -1,
    (gchar *) "AddDb",
    (GDBusArgInfo **) (&_arg_AddDb_in),
    NULL,
    NULL
};
static const GDBusMethodInfo _method_SyncDbs = {
    -1,
    (gchar *) "SyncDbs",
    NULL,
    NULL,
    NULL
};
static const GDBusArgInfo _arg_Answer_in_choice = {
    -1,
    (gchar *) "choice",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo * const _arg_Answer_in[] = {
    &_arg_Answer_in_choice,
    NULL
};
static const GDBusMethodInfo _method_Answer = {
    -1,
    (gchar *) "Answer",
    (GDBusArgInfo **) (&_arg_Answer_in),
    NULL,
    NULL
};
static const GDBusMethodInfo _method_GetPackages = {
    -1,
    (gchar *) "GetPackages",
    NULL,
    NULL,
    NULL
};
static const GDBusMethodInfo _method_SysUpgrade = {
    -1,
    (gchar *) "SysUpgrade",
    NULL,
    NULL,
    NULL
};
static const GDBusMethodInfo _method_Abort = {
    -1,
    (gchar *) "Abort",
    NULL,
    NULL,
    NULL
};
static const GDBusMethodInfo _method_NoSysUpgrade = {
    -1,
    (gchar *) "NoSysUpgrade",
    NULL,
    NULL,
    NULL
};
static const GDBusMethodInfo _method_FreeAlpm = {
    -1,
    (gchar *) "FreeAlpm",
    NULL,
    NULL,
    NULL
};
static const GDBusArgInfo _arg_MethodFailed_name = {
    -1,
    (gchar *) "name",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_MethodFailed_msg = {
    -1,
    (gchar *) "msg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_MethodFailed_in[] = {
    &_arg_MethodFailed_name,
    &_arg_MethodFailed_msg,
    NULL
};
static const GDBusSignalInfo _signal_MethodFailed = {
    -1,
    (gchar *) "MethodFailed",
    (GDBusArgInfo **) (&_arg_MethodFailed_in),
    NULL
};
static const GDBusArgInfo _arg_MethodFinished_name = {
    -1,
    (gchar *) "name",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_MethodFinished_in[] = {
    &_arg_MethodFinished_name,
    NULL
};
static const GDBusSignalInfo _signal_MethodFinished = {
    -1,
    (gchar *) "MethodFinished",
    (GDBusArgInfo **) (&_arg_MethodFinished_in),
    NULL
};
static const GDBusArgInfo _arg_GetPackagesFinished_pkgs = {
    -1,
    (gchar *) "pkgs",
    (gchar *) "a(sssssuuu)",
    NULL
};
static const GDBusArgInfo * const _arg_GetPackagesFinished_in[] = {
    &_arg_GetPackagesFinished_pkgs,
    NULL
};
static const GDBusSignalInfo _signal_GetPackagesFinished = {
    -1,
    (gchar *) "GetPackagesFinished",
    (GDBusArgInfo **) (&_arg_GetPackagesFinished_in),
    NULL
};
static const GDBusArgInfo _arg_Downloading_filename = {
    -1,
    (gchar *) "filename",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_Downloading_transfered = {
    -1,
    (gchar *) "transfered",
    (gchar *) "u",
    NULL
};
static const GDBusArgInfo _arg_Downloading_total = {
    -1,
    (gchar *) "total",
    (gchar *) "u",
    NULL
};
static const GDBusArgInfo * const _arg_Downloading_in[] = {
    &_arg_Downloading_filename,
    &_arg_Downloading_transfered,
    &_arg_Downloading_total,
    NULL
};
static const GDBusSignalInfo _signal_Downloading = {
    -1,
    (gchar *) "Downloading",
    (GDBusArgInfo **) (&_arg_Downloading_in),
    NULL
};
static const GDBusArgInfo _arg_SyncDbs_nb = {
    -1,
    (gchar *) "nb",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo * const _arg_SyncDbs_in[] = {
    &_arg_SyncDbs_nb,
    NULL
};
static const GDBusSignalInfo _signal_SyncDbs = {
    -1,
    (gchar *) "SyncDbs",
    (GDBusArgInfo **) (&_arg_SyncDbs_in),
    NULL
};
static const GDBusArgInfo _arg_SyncDbStart_name = {
    -1,
    (gchar *) "name",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_SyncDbStart_in[] = {
    &_arg_SyncDbStart_name,
    NULL
};
static const GDBusSignalInfo _signal_SyncDbStart = {
    -1,
    (gchar *) "SyncDbStart",
    (GDBusArgInfo **) (&_arg_SyncDbStart_in),
    NULL
};
static const GDBusArgInfo _arg_SyncDbEnd_result = {
    -1,
    (gchar *) "result",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo * const _arg_SyncDbEnd_in[] = {
    &_arg_SyncDbEnd_result,
    NULL
};
static const GDBusSignalInfo _signal_SyncDbEnd = {
    -1,
    (gchar *) "SyncDbEnd",
    (GDBusArgInfo **) (&_arg_SyncDbEnd_in),
    NULL
};
static const GDBusArgInfo _arg_Log_level = {
    -1,
    (gchar *) "level",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_Log_msg = {
    -1,
    (gchar *) "msg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_Log_in[] = {
    &_arg_Log_level,
    &_arg_Log_msg,
    NULL
};
static const GDBusSignalInfo _signal_Log = {
    -1,
    (gchar *) "Log",
    (GDBusArgInfo **) (&_arg_Log_in),
    NULL
};
static const GDBusArgInfo _arg_AskInstallIgnorePkg_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_AskInstallIgnorePkg_in[] = {
    &_arg_AskInstallIgnorePkg_pkg,
    NULL
};
static const GDBusSignalInfo _signal_AskInstallIgnorePkg = {
    -1,
    (gchar *) "AskInstallIgnorePkg",
    (GDBusArgInfo **) (&_arg_AskInstallIgnorePkg_in),
    NULL
};
static const GDBusArgInfo _arg_AskReplacePkg_repo1 = {
    -1,
    (gchar *) "repo1",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskReplacePkg_pkg1 = {
    -1,
    (gchar *) "pkg1",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskReplacePkg_repo2 = {
    -1,
    (gchar *) "repo2",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskReplacePkg_pkg2 = {
    -1,
    (gchar *) "pkg2",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_AskReplacePkg_in[] = {
    &_arg_AskReplacePkg_repo1,
    &_arg_AskReplacePkg_pkg1,
    &_arg_AskReplacePkg_repo2,
    &_arg_AskReplacePkg_pkg2,
    NULL
};
static const GDBusSignalInfo _signal_AskReplacePkg = {
    -1,
    (gchar *) "AskReplacePkg",
    (GDBusArgInfo **) (&_arg_AskReplacePkg_in),
    NULL
};
static const GDBusArgInfo _arg_AskConflictPkg_pkg1 = {
    -1,
    (gchar *) "pkg1",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskConflictPkg_pkg2 = {
    -1,
    (gchar *) "pkg2",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskConflictPkg_reason = {
    -1,
    (gchar *) "reason",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_AskConflictPkg_in[] = {
    &_arg_AskConflictPkg_pkg1,
    &_arg_AskConflictPkg_pkg2,
    &_arg_AskConflictPkg_reason,
    NULL
};
static const GDBusSignalInfo _signal_AskConflictPkg = {
    -1,
    (gchar *) "AskConflictPkg",
    (GDBusArgInfo **) (&_arg_AskConflictPkg_in),
    NULL
};
static const GDBusArgInfo _arg_AskRemovePkgs_pkgs = {
    -1,
    (gchar *) "pkgs",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo * const _arg_AskRemovePkgs_in[] = {
    &_arg_AskRemovePkgs_pkgs,
    NULL
};
static const GDBusSignalInfo _signal_AskRemovePkgs = {
    -1,
    (gchar *) "AskRemovePkgs",
    (GDBusArgInfo **) (&_arg_AskRemovePkgs_in),
    NULL
};
static const GDBusArgInfo _arg_AskSelectProvider_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskSelectProvider_providers = {
    -1,
    (gchar *) "providers",
    (gchar *) "aas",
    NULL
};
static const GDBusArgInfo * const _arg_AskSelectProvider_in[] = {
    &_arg_AskSelectProvider_pkg,
    &_arg_AskSelectProvider_providers,
    NULL
};
static const GDBusSignalInfo _signal_AskSelectProvider = {
    -1,
    (gchar *) "AskSelectProvider",
    (GDBusArgInfo **) (&_arg_AskSelectProvider_in),
    NULL
};
static const GDBusArgInfo _arg_AskCorruptedPkg_file = {
    -1,
    (gchar *) "file",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskCorruptedPkg_error = {
    -1,
    (gchar *) "error",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_AskCorruptedPkg_in[] = {
    &_arg_AskCorruptedPkg_file,
    &_arg_AskCorruptedPkg_error,
    NULL
};
static const GDBusSignalInfo _signal_AskCorruptedPkg = {
    -1,
    (gchar *) "AskCorruptedPkg",
    (GDBusArgInfo **) (&_arg_AskCorruptedPkg_in),
    NULL
};
static const GDBusArgInfo _arg_AskImportKey_key_fingerprint = {
    -1,
    (gchar *) "key_fingerprint",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskImportKey_key_uid = {
    -1,
    (gchar *) "key_uid",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_AskImportKey_key_created = {
    -1,
    (gchar *) "key_created",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_AskImportKey_in[] = {
    &_arg_AskImportKey_key_fingerprint,
    &_arg_AskImportKey_key_uid,
    &_arg_AskImportKey_key_created,
    NULL
};
static const GDBusSignalInfo _signal_AskImportKey = {
    -1,
    (gchar *) "AskImportKey",
    (GDBusArgInfo **) (&_arg_AskImportKey_in),
    NULL
};
static const GDBusArgInfo _arg_TotalDownload_size = {
    -1,
    (gchar *) "size",
    (gchar *) "u",
    NULL
};
static const GDBusArgInfo * const _arg_TotalDownload_in[] = {
    &_arg_TotalDownload_size,
    NULL
};
static const GDBusSignalInfo _signal_TotalDownload = {
    -1,
    (gchar *) "TotalDownload",
    (GDBusArgInfo **) (&_arg_TotalDownload_in),
    NULL
};
static const GDBusArgInfo _arg_Event_type = {
    -1,
    (gchar *) "type",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo * const _arg_Event_in[] = {
    &_arg_Event_type,
    NULL
};
static const GDBusSignalInfo _signal_Event = {
    -1,
    (gchar *) "Event",
    (GDBusArgInfo **) (&_arg_Event_in),
    NULL
};
static const GDBusArgInfo _arg_EventHookRun_type = {
    -1,
    (gchar *) "type",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_EventHookRun_total = {
    -1,
    (gchar *) "total",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_EventHookRun_position = {
    -1,
    (gchar *) "position",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_EventHookRun_hook = {
    -1,
    (gchar *) "hook",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventHookRun_desc = {
    -1,
    (gchar *) "desc",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventHookRun_in[] = {
    &_arg_EventHookRun_type,
    &_arg_EventHookRun_total,
    &_arg_EventHookRun_position,
    &_arg_EventHookRun_hook,
    &_arg_EventHookRun_desc,
    NULL
};
static const GDBusSignalInfo _signal_EventHookRun = {
    -1,
    (gchar *) "EventHookRun",
    (GDBusArgInfo **) (&_arg_EventHookRun_in),
    NULL
};
static const GDBusArgInfo _arg_EventInstalled_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventInstalled_version = {
    -1,
    (gchar *) "version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventInstalled_optdeps = {
    -1,
    (gchar *) "optdeps",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo * const _arg_EventInstalled_in[] = {
    &_arg_EventInstalled_pkg,
    &_arg_EventInstalled_version,
    &_arg_EventInstalled_optdeps,
    NULL
};
static const GDBusSignalInfo _signal_EventInstalled = {
    -1,
    (gchar *) "EventInstalled",
    (GDBusArgInfo **) (&_arg_EventInstalled_in),
    NULL
};
static const GDBusArgInfo _arg_EventReinstalled_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventReinstalled_version = {
    -1,
    (gchar *) "version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventReinstalled_in[] = {
    &_arg_EventReinstalled_pkg,
    &_arg_EventReinstalled_version,
    NULL
};
static const GDBusSignalInfo _signal_EventReinstalled = {
    -1,
    (gchar *) "EventReinstalled",
    (GDBusArgInfo **) (&_arg_EventReinstalled_in),
    NULL
};
static const GDBusArgInfo _arg_EventRemoved_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventRemoved_version = {
    -1,
    (gchar *) "version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventRemoved_in[] = {
    &_arg_EventRemoved_pkg,
    &_arg_EventRemoved_version,
    NULL
};
static const GDBusSignalInfo _signal_EventRemoved = {
    -1,
    (gchar *) "EventRemoved",
    (GDBusArgInfo **) (&_arg_EventRemoved_in),
    NULL
};
static const GDBusArgInfo _arg_EventUpgraded_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventUpgraded_old_version = {
    -1,
    (gchar *) "old_version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventUpgraded_new_version = {
    -1,
    (gchar *) "new_version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventUpgraded_newoptdeps = {
    -1,
    (gchar *) "newoptdeps",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo * const _arg_EventUpgraded_in[] = {
    &_arg_EventUpgraded_pkg,
    &_arg_EventUpgraded_old_version,
    &_arg_EventUpgraded_new_version,
    &_arg_EventUpgraded_newoptdeps,
    NULL
};
static const GDBusSignalInfo _signal_EventUpgraded = {
    -1,
    (gchar *) "EventUpgraded",
    (GDBusArgInfo **) (&_arg_EventUpgraded_in),
    NULL
};
static const GDBusArgInfo _arg_EventDowngraded_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventDowngraded_old_version = {
    -1,
    (gchar *) "old_version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventDowngraded_new_version = {
    -1,
    (gchar *) "new_version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventDowngraded_newoptdeps = {
    -1,
    (gchar *) "newoptdeps",
    (gchar *) "as",
    NULL
};
static const GDBusArgInfo * const _arg_EventDowngraded_in[] = {
    &_arg_EventDowngraded_pkg,
    &_arg_EventDowngraded_old_version,
    &_arg_EventDowngraded_new_version,
    &_arg_EventDowngraded_newoptdeps,
    NULL
};
static const GDBusSignalInfo _signal_EventDowngraded = {
    -1,
    (gchar *) "EventDowngraded",
    (GDBusArgInfo **) (&_arg_EventDowngraded_in),
    NULL
};
static const GDBusArgInfo _arg_EventPkgdownloadStart_file = {
    -1,
    (gchar *) "file",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventPkgdownloadStart_in[] = {
    &_arg_EventPkgdownloadStart_file,
    NULL
};
static const GDBusSignalInfo _signal_EventPkgdownloadStart = {
    -1,
    (gchar *) "EventPkgdownloadStart",
    (GDBusArgInfo **) (&_arg_EventPkgdownloadStart_in),
    NULL
};
static const GDBusArgInfo _arg_EventPkgdownloadDone_file = {
    -1,
    (gchar *) "file",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventPkgdownloadDone_in[] = {
    &_arg_EventPkgdownloadDone_file,
    NULL
};
static const GDBusSignalInfo _signal_EventPkgdownloadDone = {
    -1,
    (gchar *) "EventPkgdownloadDone",
    (GDBusArgInfo **) (&_arg_EventPkgdownloadDone_in),
    NULL
};
static const GDBusArgInfo _arg_EventPkgdownloadFailed_file = {
    -1,
    (gchar *) "file",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventPkgdownloadFailed_in[] = {
    &_arg_EventPkgdownloadFailed_file,
    NULL
};
static const GDBusSignalInfo _signal_EventPkgdownloadFailed = {
    -1,
    (gchar *) "EventPkgdownloadFailed",
    (GDBusArgInfo **) (&_arg_EventPkgdownloadFailed_in),
    NULL
};
static const GDBusArgInfo _arg_EventScriptlet_msg = {
    -1,
    (gchar *) "msg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventScriptlet_in[] = {
    &_arg_EventScriptlet_msg,
    NULL
};
static const GDBusSignalInfo _signal_EventScriptlet = {
    -1,
    (gchar *) "EventScriptlet",
    (GDBusArgInfo **) (&_arg_EventScriptlet_in),
    NULL
};
static const GDBusArgInfo _arg_EventPacnewCreated_from_noupgrade = {
    -1,
    (gchar *) "from_noupgrade",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_EventPacnewCreated_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventPacnewCreated_old_version = {
    -1,
    (gchar *) "old_version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventPacnewCreated_new_version = {
    -1,
    (gchar *) "new_version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventPacnewCreated_file = {
    -1,
    (gchar *) "file",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventPacnewCreated_in[] = {
    &_arg_EventPacnewCreated_from_noupgrade,
    &_arg_EventPacnewCreated_pkg,
    &_arg_EventPacnewCreated_old_version,
    &_arg_EventPacnewCreated_new_version,
    &_arg_EventPacnewCreated_file,
    NULL
};
static const GDBusSignalInfo _signal_EventPacnewCreated = {
    -1,
    (gchar *) "EventPacnewCreated",
    (GDBusArgInfo **) (&_arg_EventPacnewCreated_in),
    NULL
};
static const GDBusArgInfo _arg_EventPacsaveCreated_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventPacsaveCreated_version = {
    -1,
    (gchar *) "version",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventPacsaveCreated_file = {
    -1,
    (gchar *) "file",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventPacsaveCreated_in[] = {
    &_arg_EventPacsaveCreated_pkg,
    &_arg_EventPacsaveCreated_version,
    &_arg_EventPacsaveCreated_file,
    NULL
};
static const GDBusSignalInfo _signal_EventPacsaveCreated = {
    -1,
    (gchar *) "EventPacsaveCreated",
    (GDBusArgInfo **) (&_arg_EventPacsaveCreated_in),
    NULL
};
static const GDBusArgInfo _arg_EventDeltaGenerating_delta = {
    -1,
    (gchar *) "delta",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventDeltaGenerating_dest = {
    -1,
    (gchar *) "dest",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventDeltaGenerating_in[] = {
    &_arg_EventDeltaGenerating_delta,
    &_arg_EventDeltaGenerating_dest,
    NULL
};
static const GDBusSignalInfo _signal_EventDeltaGenerating = {
    -1,
    (gchar *) "EventDeltaGenerating",
    (GDBusArgInfo **) (&_arg_EventDeltaGenerating_in),
    NULL
};
static const GDBusArgInfo _arg_EventOptdepRemoval_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_EventOptdepRemoval_optdep = {
    -1,
    (gchar *) "optdep",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_EventOptdepRemoval_in[] = {
    &_arg_EventOptdepRemoval_pkg,
    &_arg_EventOptdepRemoval_optdep,
    NULL
};
static const GDBusSignalInfo _signal_EventOptdepRemoval = {
    -1,
    (gchar *) "EventOptdepRemoval",
    (GDBusArgInfo **) (&_arg_EventOptdepRemoval_in),
    NULL
};
static const GDBusArgInfo _arg_Progress_event = {
    -1,
    (gchar *) "event",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_Progress_pkg = {
    -1,
    (gchar *) "pkg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo _arg_Progress_percent = {
    -1,
    (gchar *) "percent",
    (gchar *) "i",
    NULL
};
static const GDBusArgInfo _arg_Progress_total = {
    -1,
    (gchar *) "total",
    (gchar *) "u",
    NULL
};
static const GDBusArgInfo _arg_Progress_current = {
    -1,
    (gchar *) "current",
    (gchar *) "u",
    NULL
};
static const GDBusArgInfo * const _arg_Progress_in[] = {
    &_arg_Progress_event,
    &_arg_Progress_pkg,
    &_arg_Progress_percent,
    &_arg_Progress_total,
    &_arg_Progress_current,
    NULL
};
static const GDBusSignalInfo _signal_Progress = {
    -1,
    (gchar *) "Progress",
    (GDBusArgInfo **) (&_arg_Progress_in),
    NULL
};
static const GDBusArgInfo _arg_Debug_msg = {
    -1,
    (gchar *) "msg",
    (gchar *) "s",
    NULL
};
static const GDBusArgInfo * const _arg_Debug_in[] = {
    &_arg_Debug_msg,
    NULL
};
static const GDBusSignalInfo _signal_Debug = {
    -1,
    (gchar *) "Debug",
    (GDBusArgInfo **) (&_arg_Debug_in),
    NULL
};
static const GDBusMethodInfo * const _methods[] = {
    &_method_Init,
    &_method_InitAlpm,
    &_method_AddDb,
    &_method_SyncDbs,
    &_method_Answer,
    &_method_GetPackages,
    &_method_SysUpgrade,
    &_method_Abort,
    &_method_NoSysUpgrade,
    &_method_FreeAlpm,
    NULL
};
static const GDBusSignalInfo * const _signals[] = {
    &_signal_MethodFailed,
    &_signal_MethodFinished,
    &_signal_GetPackagesFinished,
    &_signal_Downloading,
    &_signal_SyncDbs,
    &_signal_SyncDbStart,
    &_signal_SyncDbEnd,
    &_signal_Log,
    &_signal_AskInstallIgnorePkg,
    &_signal_AskReplacePkg,
    &_signal_AskConflictPkg,
    &_signal_AskRemovePkgs,
    &_signal_AskSelectProvider,
    &_signal_AskCorruptedPkg,
    &_signal_AskImportKey,
    &_signal_TotalDownload,
    &_signal_Event,
    &_signal_EventHookRun,
    &_signal_EventInstalled,
    &_signal_EventReinstalled,
    &_signal_EventRemoved,
    &_signal_EventUpgraded,
    &_signal_EventDowngraded,
    &_signal_EventPkgdownloadStart,
    &_signal_EventPkgdownloadDone,
    &_signal_EventPkgdownloadFailed,
    &_signal_EventScriptlet,
    &_signal_EventPacnewCreated,
    &_signal_EventPacsaveCreated,
    &_signal_EventDeltaGenerating,
    &_signal_EventOptdepRemoval,
    &_signal_Progress,
    &_signal_Debug,
    NULL
};
const GDBusInterfaceInfo interface_info = {
    -1,
    (gchar *) "org.jjk.kalu.UpdaterInterface",
    (GDBusMethodInfo **) (&_methods),
    (GDBusSignalInfo **) (&_signals),
    NULL,
    NULL
};
#endif /* _KALU_UPDATER_DBUS_H */ 
